/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataFactoryLinkedServiceSftpConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#additional_properties DataFactoryLinkedServiceSftp#additional_properties}
    */
    readonly additionalProperties?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#annotations DataFactoryLinkedServiceSftp#annotations}
    */
    readonly annotations?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#authentication_type DataFactoryLinkedServiceSftp#authentication_type}
    */
    readonly authenticationType: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#data_factory_id DataFactoryLinkedServiceSftp#data_factory_id}
    */
    readonly dataFactoryId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#description DataFactoryLinkedServiceSftp#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#host DataFactoryLinkedServiceSftp#host}
    */
    readonly host: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#host_key_fingerprint DataFactoryLinkedServiceSftp#host_key_fingerprint}
    */
    readonly hostKeyFingerprint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#id DataFactoryLinkedServiceSftp#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#integration_runtime_name DataFactoryLinkedServiceSftp#integration_runtime_name}
    */
    readonly integrationRuntimeName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#name DataFactoryLinkedServiceSftp#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#parameters DataFactoryLinkedServiceSftp#parameters}
    */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#password DataFactoryLinkedServiceSftp#password}
    */
    readonly password?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#port DataFactoryLinkedServiceSftp#port}
    */
    readonly port: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#private_key_content_base64 DataFactoryLinkedServiceSftp#private_key_content_base64}
    */
    readonly privateKeyContentBase64?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#private_key_passphrase DataFactoryLinkedServiceSftp#private_key_passphrase}
    */
    readonly privateKeyPassphrase?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#private_key_path DataFactoryLinkedServiceSftp#private_key_path}
    */
    readonly privateKeyPath?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#skip_host_key_validation DataFactoryLinkedServiceSftp#skip_host_key_validation}
    */
    readonly skipHostKeyValidation?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#username DataFactoryLinkedServiceSftp#username}
    */
    readonly username: string;
    /**
    * key_vault_password block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#key_vault_password DataFactoryLinkedServiceSftp#key_vault_password}
    */
    readonly keyVaultPassword?: DataFactoryLinkedServiceSftpKeyVaultPassword[] | cdktf.IResolvable;
    /**
    * key_vault_private_key_content_base64 block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#key_vault_private_key_content_base64 DataFactoryLinkedServiceSftp#key_vault_private_key_content_base64}
    */
    readonly keyVaultPrivateKeyContentBase64?: DataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64;
    /**
    * key_vault_private_key_passphrase block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#key_vault_private_key_passphrase DataFactoryLinkedServiceSftp#key_vault_private_key_passphrase}
    */
    readonly keyVaultPrivateKeyPassphrase?: DataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphrase;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#timeouts DataFactoryLinkedServiceSftp#timeouts}
    */
    readonly timeouts?: DataFactoryLinkedServiceSftpTimeouts;
}
export interface DataFactoryLinkedServiceSftpKeyVaultPassword {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#linked_service_name DataFactoryLinkedServiceSftp#linked_service_name}
    */
    readonly linkedServiceName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#secret_name DataFactoryLinkedServiceSftp#secret_name}
    */
    readonly secretName: string;
}
export declare function dataFactoryLinkedServiceSftpKeyVaultPasswordToTerraform(struct?: DataFactoryLinkedServiceSftpKeyVaultPassword | cdktf.IResolvable): any;
export declare function dataFactoryLinkedServiceSftpKeyVaultPasswordToHclTerraform(struct?: DataFactoryLinkedServiceSftpKeyVaultPassword | cdktf.IResolvable): any;
export declare class DataFactoryLinkedServiceSftpKeyVaultPasswordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataFactoryLinkedServiceSftpKeyVaultPassword | cdktf.IResolvable | undefined;
    set internalValue(value: DataFactoryLinkedServiceSftpKeyVaultPassword | cdktf.IResolvable | undefined);
    private _linkedServiceName?;
    get linkedServiceName(): string;
    set linkedServiceName(value: string);
    get linkedServiceNameInput(): string | undefined;
    private _secretName?;
    get secretName(): string;
    set secretName(value: string);
    get secretNameInput(): string | undefined;
}
export declare class DataFactoryLinkedServiceSftpKeyVaultPasswordList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataFactoryLinkedServiceSftpKeyVaultPassword[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataFactoryLinkedServiceSftpKeyVaultPasswordOutputReference;
}
export interface DataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64 {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#linked_service_name DataFactoryLinkedServiceSftp#linked_service_name}
    */
    readonly linkedServiceName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#secret_name DataFactoryLinkedServiceSftp#secret_name}
    */
    readonly secretName: string;
}
export declare function dataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64ToTerraform(struct?: DataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64OutputReference | DataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64): any;
export declare function dataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64ToHclTerraform(struct?: DataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64OutputReference | DataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64): any;
export declare class DataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64 | undefined;
    set internalValue(value: DataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64 | undefined);
    private _linkedServiceName?;
    get linkedServiceName(): string;
    set linkedServiceName(value: string);
    get linkedServiceNameInput(): string | undefined;
    private _secretName?;
    get secretName(): string;
    set secretName(value: string);
    get secretNameInput(): string | undefined;
}
export interface DataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphrase {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#linked_service_name DataFactoryLinkedServiceSftp#linked_service_name}
    */
    readonly linkedServiceName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#secret_name DataFactoryLinkedServiceSftp#secret_name}
    */
    readonly secretName: string;
}
export declare function dataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphraseToTerraform(struct?: DataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphraseOutputReference | DataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphrase): any;
export declare function dataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphraseToHclTerraform(struct?: DataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphraseOutputReference | DataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphrase): any;
export declare class DataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphraseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphrase | undefined;
    set internalValue(value: DataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphrase | undefined);
    private _linkedServiceName?;
    get linkedServiceName(): string;
    set linkedServiceName(value: string);
    get linkedServiceNameInput(): string | undefined;
    private _secretName?;
    get secretName(): string;
    set secretName(value: string);
    get secretNameInput(): string | undefined;
}
export interface DataFactoryLinkedServiceSftpTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#create DataFactoryLinkedServiceSftp#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#delete DataFactoryLinkedServiceSftp#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#read DataFactoryLinkedServiceSftp#read}
    */
    readonly read?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#update DataFactoryLinkedServiceSftp#update}
    */
    readonly update?: string;
}
export declare function dataFactoryLinkedServiceSftpTimeoutsToTerraform(struct?: DataFactoryLinkedServiceSftpTimeouts | cdktf.IResolvable): any;
export declare function dataFactoryLinkedServiceSftpTimeoutsToHclTerraform(struct?: DataFactoryLinkedServiceSftpTimeouts | cdktf.IResolvable): any;
export declare class DataFactoryLinkedServiceSftpTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataFactoryLinkedServiceSftpTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataFactoryLinkedServiceSftpTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _read?;
    get read(): string;
    set read(value: string);
    resetRead(): void;
    get readInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp azurerm_data_factory_linked_service_sftp}
*/
export declare class DataFactoryLinkedServiceSftp extends cdktf.TerraformResource {
    static readonly tfResourceType = "azurerm_data_factory_linked_service_sftp";
    /**
    * Generates CDKTF code for importing a DataFactoryLinkedServiceSftp resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataFactoryLinkedServiceSftp to import
    * @param importFromId The id of the existing DataFactoryLinkedServiceSftp that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataFactoryLinkedServiceSftp to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/azurerm/4.31.0/docs/resources/data_factory_linked_service_sftp azurerm_data_factory_linked_service_sftp} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataFactoryLinkedServiceSftpConfig
    */
    constructor(scope: Construct, id: string, config: DataFactoryLinkedServiceSftpConfig);
    private _additionalProperties?;
    get additionalProperties(): {
        [key: string]: string;
    };
    set additionalProperties(value: {
        [key: string]: string;
    });
    resetAdditionalProperties(): void;
    get additionalPropertiesInput(): {
        [key: string]: string;
    } | undefined;
    private _annotations?;
    get annotations(): string[];
    set annotations(value: string[]);
    resetAnnotations(): void;
    get annotationsInput(): string[] | undefined;
    private _authenticationType?;
    get authenticationType(): string;
    set authenticationType(value: string);
    get authenticationTypeInput(): string | undefined;
    private _dataFactoryId?;
    get dataFactoryId(): string;
    set dataFactoryId(value: string);
    get dataFactoryIdInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _host?;
    get host(): string;
    set host(value: string);
    get hostInput(): string | undefined;
    private _hostKeyFingerprint?;
    get hostKeyFingerprint(): string;
    set hostKeyFingerprint(value: string);
    resetHostKeyFingerprint(): void;
    get hostKeyFingerprintInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _integrationRuntimeName?;
    get integrationRuntimeName(): string;
    set integrationRuntimeName(value: string);
    resetIntegrationRuntimeName(): void;
    get integrationRuntimeNameInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _parameters?;
    get parameters(): {
        [key: string]: string;
    };
    set parameters(value: {
        [key: string]: string;
    });
    resetParameters(): void;
    get parametersInput(): {
        [key: string]: string;
    } | undefined;
    private _password?;
    get password(): string;
    set password(value: string);
    resetPassword(): void;
    get passwordInput(): string | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    get portInput(): number | undefined;
    private _privateKeyContentBase64?;
    get privateKeyContentBase64(): string;
    set privateKeyContentBase64(value: string);
    resetPrivateKeyContentBase64(): void;
    get privateKeyContentBase64Input(): string | undefined;
    private _privateKeyPassphrase?;
    get privateKeyPassphrase(): string;
    set privateKeyPassphrase(value: string);
    resetPrivateKeyPassphrase(): void;
    get privateKeyPassphraseInput(): string | undefined;
    private _privateKeyPath?;
    get privateKeyPath(): string;
    set privateKeyPath(value: string);
    resetPrivateKeyPath(): void;
    get privateKeyPathInput(): string | undefined;
    private _skipHostKeyValidation?;
    get skipHostKeyValidation(): boolean | cdktf.IResolvable;
    set skipHostKeyValidation(value: boolean | cdktf.IResolvable);
    resetSkipHostKeyValidation(): void;
    get skipHostKeyValidationInput(): boolean | cdktf.IResolvable | undefined;
    private _username?;
    get username(): string;
    set username(value: string);
    get usernameInput(): string | undefined;
    private _keyVaultPassword;
    get keyVaultPassword(): DataFactoryLinkedServiceSftpKeyVaultPasswordList;
    putKeyVaultPassword(value: DataFactoryLinkedServiceSftpKeyVaultPassword[] | cdktf.IResolvable): void;
    resetKeyVaultPassword(): void;
    get keyVaultPasswordInput(): cdktf.IResolvable | DataFactoryLinkedServiceSftpKeyVaultPassword[] | undefined;
    private _keyVaultPrivateKeyContentBase64;
    get keyVaultPrivateKeyContentBase64(): DataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64OutputReference;
    putKeyVaultPrivateKeyContentBase64(value: DataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64): void;
    resetKeyVaultPrivateKeyContentBase64(): void;
    get keyVaultPrivateKeyContentBase64Input(): DataFactoryLinkedServiceSftpKeyVaultPrivateKeyContentBase64 | undefined;
    private _keyVaultPrivateKeyPassphrase;
    get keyVaultPrivateKeyPassphrase(): DataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphraseOutputReference;
    putKeyVaultPrivateKeyPassphrase(value: DataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphrase): void;
    resetKeyVaultPrivateKeyPassphrase(): void;
    get keyVaultPrivateKeyPassphraseInput(): DataFactoryLinkedServiceSftpKeyVaultPrivateKeyPassphrase | undefined;
    private _timeouts;
    get timeouts(): DataFactoryLinkedServiceSftpTimeoutsOutputReference;
    putTimeouts(value: DataFactoryLinkedServiceSftpTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataFactoryLinkedServiceSftpTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
